MapDigraph (cayenne-doc: Cayenne Documentation 5.0-M2 API)
Description: declaration: package: org.apache.cayenne.ashwood.graph, class: MapDigraph

# Class MapDigraph<E,V>

java.lang.Object
org.apache.cayenne.ashwood.graph.MapDigraph<E,V>

All Implemented Interfaces:
  `Digraph<E,V>, DigraphIteration<E,V>`

public class MapDigraph<E,V> extends Object implements Digraph<E,V>

Since:
  3.1

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MapDigraph()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `addAllVertices(Collection<? extends E> vertices)`
  `boolean`
  `addVertex(E vertex)`
  `ArcIterator<E,V>`
  `arcIterator()`
  `boolean`
  `containsAllVertices(Collection<? extends E> vertices)`
  `boolean`
  `containsVertex(E vertex)`
  `V`
  `getArc(Object origin, Object destination)`
  `boolean`
  `hasArc(E origin, E destination)`
  `ArcIterator<E,V>`
  `incomingIterator(E vertex)`
  `int`
  `incomingSize(E vertex)`
  `boolean`
  `isEmpty()`
  `boolean`
  `isIncomingEmpty(E vertex)`
  `boolean`
  `isOutgoingEmpty(E vertex)`
  `int`
  `order()`
  `ArcIterator<E,V>`
  `outgoingIterator(E vertex)`
  `int`
  `outgoingSize(E vertex)`
  `V`
  `putArc(E origin, E destination, V arc)`
  `boolean`
  `removeAllVertices(Collection<? extends E> vertices)`
  `Object`
  `removeArc(E origin, E destination)`
  `boolean`
  `removeIncoming(E vertex)`
  `boolean`
  `removeOutgoing(E vertex)`
  `boolean`
  `removeVertex(E vertex)`
  `int`
  `size()`
  `Iterator<E>`
  `vertexIterator()`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### MapDigraph

    public MapDigraph()

- ## Method Details

  - ### addVertex

    public boolean addVertex(E vertex)
    Specified by:
      `addVertex` in interface `Digraph<E,V>`

  - ### addAllVertices

    public boolean addAllVertices(Collection<? extends E> vertices)
    Specified by:
      `addAllVertices` in interface `Digraph<E,V>`

  - ### putArc

    public V putArc(E origin, E destination, V arc)
    Specified by:
      `putArc` in interface `Digraph<E,V>`

  - ### getArc

    public V getArc(Object origin, Object destination)
    Specified by:
      `getArc` in interface `Digraph<E,V>`

  - ### removeVertex

    public boolean removeVertex(E vertex)
    Specified by:
      `removeVertex` in interface `Digraph<E,V>`

  - ### removeAllVertices

    public boolean removeAllVertices(Collection<? extends E> vertices)
    Specified by:
      `removeAllVertices` in interface `Digraph<E,V>`

  - ### removeArc

    public Object removeArc(E origin, E destination)
    Specified by:
      `removeArc` in interface `Digraph<E,V>`

  - ### removeIncoming

    public boolean removeIncoming(E vertex)
    Specified by:
      `removeIncoming` in interface `Digraph<E,V>`

  - ### removeOutgoing

    public boolean removeOutgoing(E vertex)
    Specified by:
      `removeOutgoing` in interface `Digraph<E,V>`

  - ### vertexIterator

    public Iterator<E> vertexIterator()
    Specified by:
      `vertexIterator` in interface `DigraphIteration<E,V>`

  - ### arcIterator

    public ArcIterator<E,V> arcIterator()
    Specified by:
      `arcIterator` in interface `DigraphIteration<E,V>`

  - ### outgoingIterator

    public ArcIterator<E,V> outgoingIterator(E vertex)
    Specified by:
      `outgoingIterator` in interface `DigraphIteration<E,V>`

  - ### incomingIterator

    public ArcIterator<E,V> incomingIterator(E vertex)
    Specified by:
      `incomingIterator` in interface `DigraphIteration<E,V>`

  - ### order

    public int order()
    Specified by:
      `order` in interface `Digraph<E,V>`

  - ### size

    public int size()
    Specified by:
      `size` in interface `Digraph<E,V>`

  - ### outgoingSize

    public int outgoingSize(E vertex)
    Specified by:
      `outgoingSize` in interface `Digraph<E,V>`

  - ### incomingSize

    public int incomingSize(E vertex)
    Specified by:
      `incomingSize` in interface `Digraph<E,V>`

  - ### containsVertex

    public boolean containsVertex(E vertex)
    Specified by:
      `containsVertex` in interface `Digraph<E,V>`

  - ### containsAllVertices

    public boolean containsAllVertices(Collection<? extends E> vertices)
    Specified by:
      `containsAllVertices` in interface `Digraph<E,V>`

  - ### hasArc

    public boolean hasArc(E origin, E destination)
    Specified by:
      `hasArc` in interface `Digraph<E,V>`

  - ### isEmpty

    public boolean isEmpty()
    Specified by:
      `isEmpty` in interface `Digraph<E,V>`

  - ### isOutgoingEmpty

    public boolean isOutgoingEmpty(E vertex)
    Specified by:
      `isOutgoingEmpty` in interface `Digraph<E,V>`

  - ### isIncomingEmpty

    public boolean isIncomingEmpty(E vertex)
    Specified by:
      `isIncomingEmpty` in interface `Digraph<E,V>`